[project]
name = "fn_gen"
readme = "README.md"
description = "A library for usage with SCPI compliant function generators (for now the DG2000 series from rigol)"
requires-python = ">=3.9"
version = "0.0.2"
dependencies = [
    "pyvisa>=1.14.1",
    "pyvisa-py>=0.7.1",
    "setuptools>=69.1.1",
]
authors = [
    {name = "Ali Nwegy", email = "ali.el-nwegy@tuhh.de"},
]
license = {text = "MIT"}

[tool.pdm]
distribution = true

[tool.pdm.scripts]
edit = {shell = "$VISUAL src/fn_gen"}
uml = {shell = "pyreverse -o html -S --colorized -d uml src/fn_gen"}
doc = {shell = "pydoctor"}
examples = {shell = "$VISUAL examples"}
sine = "examples/sine_signal.py"
square = "examples/square_signal.py"
ramp = "examples/ramp_signal.py"
discrete_sweep = "examples/discrete_sweep.py"
sweep = "examples/sweep.py"
nsweep = "examples/sweep_2.py"
dc_signal = "examples/dc_signal.py"
stop_channel = "examples/stop_channels.py"
whoami = "examples/whoami.py"


[tool.pydoctor]
add-package = ["src/fn_gen"]
docformat = "numpy"
html-output = "docs"
intersphinx = ["https://docs.python.org/3/objects.inv", "docs/pyvisa/objects.inv"]


[tool.pdm.dev-dependencies]
dev = [
    "bpython>=0.24",
    "pylint>=3.0.3",
    "pydoctor>=23.9.1",
    "numpy>=1.26.4",
]
